import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.Timer;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.data.general.SeriesChangeListener;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection; 

//import MemoryUsage.DataGenerator;

public class Graficador extends JPanel {
	
	 /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/** The series data. */
	private XYSeries series = new XYSeries("FFT");
	private XYSeries seriesTemp = new XYSeries("FFT2");
	int nDePuntos=0;
	float f=0;
	int x,y;
    SeriesChangeListener listener = null;

    public JFreeChart chart;

    
	public Graficador(int x,int y,int nDePuntos, float f) {
		this.x=x;
		this.y=y;
		//super(title);
		//setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//setTitle(title);
		DataGenerator dataG = new DataGenerator(); 
		dataG.start();
        //DataGenerator2 dataG2 = new DataG2();
        try{
			this.nDePuntos=nDePuntos;
			this.f=f;
	    	
			for(int i=0;i<nDePuntos;i++)
		  		series.add(i*f/nDePuntos,0.0);
	
		  	final XYSeriesCollection data = new XYSeriesCollection(series);
		  	
		  	chart = createChart(data);
		  	final ChartPanel chartPanel = new ChartPanel(chart);
		  	//final JPanel content = new JPanel(new BorderLayout());
		  	chartPanel.setSize(500, 270);
	        //content.add(chartPanel);
		  	add(chartPanel);
	        
	        //add(content);
	        //setContentPane(content);
		} catch(Exception e){
			System.out.println(e);
		}
	}
	public Graficador(int x, int y) {
    	this(x,y,256,(float)22050);
    }
    /**
     * Creates a sample chart.
     * 
     * @param dataset  the dataset.
     * 
     * @return A sample chart.
     */
    private JFreeChart createChart(final XYDataset dataset) {
        final JFreeChart result = ChartFactory.createXYLineChart(
            "FFT", 
            "Frecuencia", 
            "Amplitud",
            dataset, 
            PlotOrientation.VERTICAL,
            true, 
            true, 
            false
        );
        final XYPlot plot = result.getXYPlot();
        ValueAxis axis = plot.getDomainAxis();
        axis = plot.getRangeAxis();
        axis.setRange(x, y);
        return result;
    }

	class DataGenerator extends Timer implements ActionListener {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		DataGenerator() {
		super(100, null);
		addActionListener(this);
		}
		public void actionPerformed(ActionEvent event) {
			
			for(int i=0;i<seriesTemp.getItemCount();i++)
            	series.update(i*f/nDePuntos, seriesTemp.getY(i));
			
		}
	}
	public void actualizar(XYSeries series2,int nDePuntos, float f) {
		this.nDePuntos = nDePuntos;
		this.f=f;
		seriesTemp=series2;
		//for(int i=0;i<seriesTemp.getItemCount();i++)
        //	series.update(i*f/nDePuntos, seriesTemp.getY(i));
	}
}
	
	
