import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
public class Paralelo extends JPanel{
	
	private Runtime runTime= Runtime.getRuntime();
	private Process process=null;
	BufferedReader stdout;
	PrintWriter stdin;
	private int estado;
	private ImageIcon iconNegro,iconAzul,iconRojo,iconVerde;
	private JButton led1,led2,led3;
	
	public Paralelo(){		
		//contruir los leds (dibujos)
		iconNegro = new ImageIcon("negro.png");
		iconAzul = new ImageIcon("azul.png");
		iconRojo = new ImageIcon("rojo.png");
		iconVerde = new ImageIcon("verde.png");

		led1 = new JButton("led1",iconNegro);
	    led2 = new JButton("led2",iconNegro);
	    led3 = new JButton("led3",iconNegro);
		
	    led1.addActionListener(
	    	      new ActionListener(){
	    	        public void actionPerformed(
	    	        	                 ActionEvent e){
	    	          togleLed(1);
	    	        }//end actionPerformed
	    	      }//end ActionListener
	    	    );//end addActionListener()
	    add(led1);
	    
	    led2.addActionListener(
	    	      new ActionListener(){
	    	        public void actionPerformed(
	    	        	                 ActionEvent e){
	    	          togleLed(2);
	    	        }//end actionPerformed
	    	      }//end ActionListener
	    	    );//end addActionListener()
	    add(led2);
	    
	    led3.addActionListener(
	    	      new ActionListener(){
	    	        public void actionPerformed(
	    	        	                 ActionEvent e){
	    	          togleLed(4);
	    	        }//end actionPerformed
	    	      }//end ActionListener
	    	    );//end addActionListener()
	    add(led3);
	    
		//construir la comunicacion con el programa en C (requiere ejecutar como sudo)
		try {
		      process = runTime.exec("./pp");
		      InputStreamReader inputStreamReader = new InputStreamReader(process.getInputStream());
		      stdout = new BufferedReader(inputStreamReader);
		      stdin = new PrintWriter(process.getOutputStream(),true);
		    } catch (IOException e) {
		      System.out.println("No pudimos correr paralelo: "+ e);
		      System.exit(-1);
		    }
		    estado=0;		//estado 0, todos los leds apagados
		    escribe("0"); 	//apagamos todo
	}
	public void destructor(){
		escribe("-9");
		if (process!=null)
		      process.destroy();
		try {
		      process.waitFor();
		    } catch( InterruptedException e ) {
		      System.out.println("No pudimos esperar por témino de paralelo");
		      System.exit(-1);
		    }
		    System.out.println("Estatus de témino de paralelo:  "+process.exitValue());
		    System.exit(0);
	}
	public void escribe(String linea){
		stdin.println(linea);
		
	}
	public void lee(){
		try{
			if (stdout.ready()){
				String linea = stdout.readLine();
				//System.out.println("salida de paralelo: " + linea);	
			}
		} catch (IOException e) {
		    System.out.println("No pudimos leer paralelo");
		    System.exit(-1);
		}
	}
	public void togleLed(int l){
		estado = estado^l;
		
		//actualizacion de los led en la interfaz
		switch(estado){
		case 0:
			led1.setIcon(iconNegro);
			led2.setIcon(iconNegro);
			led3.setIcon(iconNegro);
			break;
		case 1:
			led1.setIcon(iconAzul);
			led2.setIcon(iconNegro);
			led3.setIcon(iconNegro);
			break;
		case 2:
			led1.setIcon(iconNegro);
			led2.setIcon(iconRojo);
			led3.setIcon(iconNegro);
			break;
		case 3:
			led1.setIcon(iconAzul);
			led2.setIcon(iconRojo);
			led3.setIcon(iconNegro);
			break;
		case 4:
			led1.setIcon(iconNegro);
			led2.setIcon(iconNegro);
			led3.setIcon(iconVerde);
			break;
		case 5:
			led1.setIcon(iconAzul);
			led2.setIcon(iconNegro);
			led3.setIcon(iconVerde);
			break;
		case 6:
			led1.setIcon(iconNegro);
			led2.setIcon(iconRojo);
			led3.setIcon(iconVerde);
			break;
		case 7:
			led1.setIcon(iconAzul);
			led2.setIcon(iconRojo);
			led3.setIcon(iconVerde);
			break;
		}
		
		//interaccion con el paralelo
		lee(); //i hay algo que leer lo leemos
		escribe(Integer.toString(estado));
	}
	public void prendeLed(int l){
		estado = estado|l;
		
		//actualizacion de los led en la interfaz
		switch(estado){
		case 0:
			led1.setIcon(iconNegro);
			led2.setIcon(iconNegro);
			led3.setIcon(iconNegro);
			break;
		case 1:
			led1.setIcon(iconAzul);
			led2.setIcon(iconNegro);
			led3.setIcon(iconNegro);
			break;
		case 2:
			led1.setIcon(iconNegro);
			led2.setIcon(iconRojo);
			led3.setIcon(iconNegro);
			break;
		case 3:
			led1.setIcon(iconAzul);
			led2.setIcon(iconRojo);
			led3.setIcon(iconNegro);
			break;
		case 4:
			led1.setIcon(iconNegro);
			led2.setIcon(iconNegro);
			led3.setIcon(iconVerde);
			break;
		case 5:
			led1.setIcon(iconAzul);
			led2.setIcon(iconNegro);
			led3.setIcon(iconVerde);
			break;
		case 6:
			led1.setIcon(iconNegro);
			led2.setIcon(iconRojo);
			led3.setIcon(iconVerde);
			break;
		case 7:
			led1.setIcon(iconAzul);
			led2.setIcon(iconRojo);
			led3.setIcon(iconVerde);
			break;
		}
		
		//interaccion con el paralelo
		lee(); //i hay algo que leer lo leemos
		escribe(Integer.toString(estado));
	}
	public void apagaLed(int l){
		estado = estado&(~l);
		
		//actualizacion de los led en la interfaz
		switch(estado){
		case 0:
			led1.setIcon(iconNegro);
			led2.setIcon(iconNegro);
			led3.setIcon(iconNegro);
			break;
		case 1:
			led1.setIcon(iconAzul);
			led2.setIcon(iconNegro);
			led3.setIcon(iconNegro);
			break;
		case 2:
			led1.setIcon(iconNegro);
			led2.setIcon(iconRojo);
			led3.setIcon(iconNegro);
			break;
		case 3:
			led1.setIcon(iconAzul);
			led2.setIcon(iconRojo);
			led3.setIcon(iconNegro);
			break;
		case 4:
			led1.setIcon(iconNegro);
			led2.setIcon(iconNegro);
			led3.setIcon(iconVerde);
			break;
		case 5:
			led1.setIcon(iconAzul);
			led2.setIcon(iconNegro);
			led3.setIcon(iconVerde);
			break;
		case 6:
			led1.setIcon(iconNegro);
			led2.setIcon(iconRojo);
			led3.setIcon(iconVerde);
			break;
		case 7:
			led1.setIcon(iconAzul);
			led2.setIcon(iconRojo);
			led3.setIcon(iconVerde);
			break;
		}
		 
		//interaccion con el paralelo
		lee(); //i hay algo que leer lo leemos
		escribe(Integer.toString(estado));
	}
	public static void main(String args[]){
	    Paralelo pp = new Paralelo();
	    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	    String linea="0";
	    int i =Integer.parseInt(linea);
	    while(i!=-9){
	    	try {
		    	System.out.println("Cual led quiere encender (en hexadecimal)?");
		    	linea = br.readLine();
		    	i=Integer.parseInt(linea);
		    	if(i>=0 && i<=7){
			    	pp.lee();
			    	pp.escribe(linea);
		    	} else {
		    		System.out.println("debe ser un numero entre 0 y 7, o -9 para salir.");
		    	}
		    	
		    } catch (Exception e){
		    	System.out.println(e);
		    }	
	    }
	    
	    
	    
	    pp.destructor();
	    
	}
}