import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayOutputStream;
import java.io.File;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JButton;
import javax.swing.JPanel;

import org.jfree.data.xy.XYSeries;

import visad.math.FFT;
 
 
@SuppressWarnings("serial")
public class Player extends JPanel{

  boolean stopCapture = false;
  boolean stopped = false;
  ByteArrayOutputStream byteArrayOutputStream;
  AudioFormat audioFormat;
  TargetDataLine targetDataLine;
  AudioInputStream audioInputStream;
  SourceDataLine sourceDataLine;
  static byte tempBufferIP[] = new byte[1024];
  Graficador grafico;
  JButton stopBtn, play2Btn,playFileBtn,altoBtn,medioBtn,bajoBtn,tritonoBtn;
  Analizador anl;
  
  public Player(Graficador grafico, Analizador anl){//constructor
	  
	  this.grafico = grafico;
	  this.anl=anl;
	  
    stopBtn = new JButton("Stop");
   play2Btn = new JButton("Instant Playback");
    playFileBtn = new JButton("Play Example File");
    altoBtn = new JButton("Alto");
    medioBtn = new JButton("Medio");
    bajoBtn = new JButton("Bajo");
    tritonoBtn = new JButton("Tritono");
    
    play2Btn.setEnabled(true);
    playFileBtn.setEnabled(true);
    stopBtn.setEnabled(false);
    altoBtn.setEnabled(true);
    medioBtn.setEnabled(true);
    bajoBtn.setEnabled(true);
    tritonoBtn.setEnabled(true);
    
    //Register anonymous listeners
    stopBtn.addActionListener(
      new ActionListener(){
        public void actionPerformed(
        	                 ActionEvent e){
       stopp();
          //Terminate the capturing of input data
          // from the microphone.
          stopCapture = true;
          stopped=true;
        }//end actionPerformed
      }//end ActionListener
    );//end addActionListener()
    add(stopBtn);


    play2Btn.addActionListener(
    	      new ActionListener(){
    	        public void actionPerformed(
    	        	                 ActionEvent e){
    	        	stopBtn.setEnabled(true);
    	        	play2Btn.setEnabled(false);
      	          altoBtn.setEnabled(false);
    	  	        medioBtn.setEnabled(false);
    	  	        bajoBtn.setEnabled(false);
    	  	      playFileBtn.setEnabled(false);
    	  	    tritonoBtn.setEnabled(false);
    	  	    stopped=false;
    	          InstantPlayAudio();
    	        }//end actionPerformed
    	      }//end ActionListener
    	    );//end addActionListener()
    add(play2Btn);
    
    bajoBtn.addActionListener(
    	    	      new ActionListener(){
    	    	        public void actionPerformed(
    	    	        	                 ActionEvent e){
    	    	        	play();
    	      	  	          playFile("bajo.wav");
    	    	        }//end actionPerformed
    	    	      }//end ActionListener
    	    	    );//end addActionListener()
    add(bajoBtn);
    medioBtn.addActionListener(
	  	      new ActionListener(){
	  	        public void actionPerformed(
	  	        	                 ActionEvent e){
	  	        	play();
	    	  	   playFile("medio.wav");
	  	        }//end actionPerformed
	  	      }//end ActionListener
	  	    );//end addActionListener()
    add(medioBtn);
    altoBtn.addActionListener(
  	      new ActionListener(){
  	        public void actionPerformed(
  	        	                 ActionEvent e){
  	        	play();
    	  	          playFile("alto.wav");
  	        }//end actionPerformed
  	      }//end ActionListener
  	    );//end addActionListener()
  add(altoBtn);
    tritonoBtn.addActionListener(
	  	      new ActionListener(){
	  	        public void actionPerformed(
	  	        	                 ActionEvent e){
	  	          play();
	  	      playFile("tritono.wav");
	  	        }//end actionPerformed
	  	      }//end ActionListener
	  	    );//end addActionListener()
	  	add(tritonoBtn);
    playFileBtn.addActionListener(
	  	      new ActionListener(){
	  	        public void actionPerformed(
	  	        	                 ActionEvent e){
	  	          play();
	  	      playFile("Cancion.wav");
	  	        }//end actionPerformed
	  	      }//end ActionListener
	  	    );//end addActionListener()
	  	add(playFileBtn);

  	//setLayout(new FlowLayout());
    //setSize(250,150);
    //setVisible(true);
  }//end constructor

private void play(){
	stopBtn.setEnabled(true);
      play2Btn.setEnabled(false);
    altoBtn.setEnabled(false);
    medioBtn.setEnabled(false);
    bajoBtn.setEnabled(false);
  playFileBtn.setEnabled(false);
tritonoBtn.setEnabled(false);
  stopped=false;
}
private void stopp(){
	   stopBtn.setEnabled(false);
       altoBtn.setEnabled(true);
	        medioBtn.setEnabled(true);
	        bajoBtn.setEnabled(true);
	        play2Btn.setEnabled(true);
	        playFileBtn.setEnabled(true);
	        tritonoBtn.setEnabled(true);
}
  
  protected void playFile(String archivo) {
	  try{
	  audioInputStream = AudioSystem.getAudioInputStream(new File(archivo));
      audioFormat = audioInputStream.getFormat();
      DataLine.Info dataLineInfo = new DataLine.Info(SourceDataLine.class,audioFormat);
      sourceDataLine = (SourceDataLine) AudioSystem.getLine(dataLineInfo);
      sourceDataLine.open(audioFormat);
      sourceDataLine.start();

      //Create a thread to play back the data and
      // start it  running.  It will run until
      // all the data has been played back.
      Thread playFileThread = new PlayFileThread();
      playFileThread.start();
	  } catch (Exception e) {
	      System.out.println(e);
	      System.exit(0);
	    }//end catch
	  }//end playAudio

protected void InstantPlayAudio() {
	  try{
	      //Get and display a list of
	      // available mixers.
	      Mixer.Info[] mixerInfo = 
	                      AudioSystem.getMixerInfo();
	      System.out.println("Available mixers:");
	      for(int cnt = 0; cnt < mixerInfo.length;
	                                          cnt++){
	      	System.out.println(mixerInfo[cnt].
	      	                              getName());
	      }//end for loop

	      //Get everything set up for capture
	      audioFormat = getAudioFormat();

	      DataLine.Info dataLineInfo =
	                            new DataLine.Info(
	                            TargetDataLine.class,
	                            audioFormat);

	      //Select one of the available
	      // mixers.
	      Mixer mixer = AudioSystem.
	                          getMixer(mixerInfo[3]);
	      
	      //Get a TargetDataLine on the selected
	      // mixer.
	      targetDataLine = (TargetDataLine)
	                     mixer.getLine(dataLineInfo);
	      //Prepare the line for use.
	      targetDataLine.open(audioFormat);
	      targetDataLine.start();

	      AudioFormat audioFormat = getAudioFormat();
	      DataLine.Info sourceDataLineInfo = new DataLine.Info(SourceDataLine.class,audioFormat);
	      sourceDataLine = (SourceDataLine)AudioSystem.getLine(sourceDataLineInfo);
	      sourceDataLine.open(audioFormat);
	      sourceDataLine.start();
	      
	      //Create a thread to play back the data and
	      // start it  running.  It will run until
	      // all the data has been played back.
	      Thread instantPlayThread = new instantPlayThread();
	      instantPlayThread.start();
	    } catch (Exception e) {
	      System.out.println(e);
	      System.exit(0);
	    }//end catch
	
}


  //This method creates and returns an
  // AudioFormat object for a given set of format
  // parameters.  If these parameters don't work
  // well for you, try some of the other
  // allowable parameter values, which are shown
  // in comments following the declarations.
  private AudioFormat getAudioFormat(){
    float sampleRate = 44100.0F;
    //8000,11025,16000,22050,44100
    int sampleSizeInBits = 16;
    //8,16
    int channels = 1;
    //1,2
    boolean signed = true;
    //true,false
    boolean bigEndian = false;
    //true,false
    return new AudioFormat(
                      sampleRate,
                      sampleSizeInBits,
                      channels,
                      signed,
                      bigEndian);
  }//end getAudioFormat
//===================================//

class PlayFileThread extends Thread{
	int numBytesRead, i;
	FFT fft = new FFT();

	public void run(){
	    try{
	    	AudioFormat format = audioInputStream.getFormat();
	    	XYSeries series=new XYSeries("FFT");
	while (!stopped){
	
		int numBytesRead = audioInputStream.read(tempBufferIP, 0, tempBufferIP.length);
		if (numBytesRead == -1) break;
		double[][] audioDataConv = null;
	    if (format.getSampleSizeInBits() == 16) {
	          int nlengthInSamples = tempBufferIP.length / 2;
	          audioDataConv = new double [2][nlengthInSamples];
	          if (format.isBigEndian()) {
	             for (int i = 0; i < nlengthInSamples; i++) {
	                  /* First byte is MSB (high order) */
	                  int MSB = (int) tempBufferIP[2*i];
	                  /* Second byte is LSB (low order) */
	                  int LSB = (int) tempBufferIP[2*i+1];
	                  audioDataConv[0][i] = MSB << 8 | (255 & LSB);
	              }
	          } else {
	              for (int i = 0; i < nlengthInSamples; i++) {
	                  /* First byte is LSB (low order) */
	                  int LSB = (int) tempBufferIP[2*i];
	                  /* Second byte is MSB (high order) */
	                  int MSB = (int) tempBufferIP[2*i+1];
	                  audioDataConv[0][i] = MSB << 8 | (255 & LSB);
	              }
	          }
	    } else if (format.getSampleSizeInBits() == 8) {
	          int nlengthInSamples = tempBufferIP.length;
	          audioDataConv = new double[2][nlengthInSamples];
	          if (format.getEncoding().toString().startsWith("PCM_SIGN")) {
	              for (int i = 0; i < tempBufferIP.length; i++) {
	                  audioDataConv[0][i] = tempBufferIP[i];
	              }
	          } else {
	              for (int i = 0; i < tempBufferIP.length; i++) {
	                  audioDataConv[0][i] = tempBufferIP[i] - 128;
	              }
	          }
	    }
	    series.clear();
	    final double[][] audioDataFFT = FFT.FFT1D(audioDataConv, true); 
	    for(i=0;i<audioDataFFT[0].length/2;i++)
	    	  series.add(i*(format.getSampleRate()/2)/(audioDataFFT[0].length/2),Math.log10(Math.abs(audioDataFFT[0][i]))*10);   
		
	    if(numBytesRead==tempBufferIP.length){
			grafico.actualizar(series,tempBufferIP.length/4,format.getSampleRate()/2);
			anl.analiza(series);
		}
		
		sourceDataLine.write(tempBufferIP, 0, numBytesRead);
			}
	stopp();
	 sourceDataLine.drain();
     sourceDataLine.close();
	    }catch (Exception e) {
	        System.out.println(e);
	        System.exit(0);
	      }//end catch
	}
}

class instantPlayThread extends Thread
{
	
	int numBytesRead, i;
	FFT fft = new FFT();

	public void run(){
	    try{
	    	AudioFormat format = targetDataLine.getFormat();
	    	//grafico = new Graficador("FFT", tempBufferIP.length/4,format.getSampleRate()/2);
	    	//grafico.pack();
	  	  	//grafico.setVisible(true);
	    	//add(grafico);
	    	XYSeries series = new XYSeries("FFT");
	while (!stopped){
	
		int numBytesRead = targetDataLine.read(tempBufferIP, 0, tempBufferIP.length);
		if (numBytesRead == -1) break;
		
		 double[][] audioDataConv = null;
	      if (format.getSampleSizeInBits() == 16) {
	          int nlengthInSamples = tempBufferIP.length / 2;
	          audioDataConv = new double [2][nlengthInSamples];
	          if (format.isBigEndian()) {
	             for (int i = 0; i < nlengthInSamples; i++) {
	                  /* First byte is MSB (high order) */
	                  int MSB = (int) tempBufferIP[2*i];
	                  /* Second byte is LSB (low order) */
	                  int LSB = (int) tempBufferIP[2*i+1];
	                  audioDataConv[0][i] = MSB << 8 | (255 & LSB);
	              }
	          } else {
	              for (int i = 0; i < nlengthInSamples; i++) {
	                  /* First byte is LSB (low order) */
	                  int LSB = (int) tempBufferIP[2*i];
	                  /* Second byte is MSB (high order) */
	                  int MSB = (int) tempBufferIP[2*i+1];
	                  audioDataConv[0][i] = MSB << 8 | (255 & LSB);
	              }
	          }
	      } else if (format.getSampleSizeInBits() == 8) {
	          int nlengthInSamples = tempBufferIP.length;
	          audioDataConv = new double[2][nlengthInSamples];
	          if (format.getEncoding().toString().startsWith("PCM_SIGN")) {
	              for (int i = 0; i < tempBufferIP.length; i++) {
	                  audioDataConv[0][i] = tempBufferIP[i];
	              }
	          } else {
	              for (int i = 0; i < tempBufferIP.length; i++) {
	                  audioDataConv[0][i] = tempBufferIP[i] - 128;
	              }
	          }
	     }
	      series.clear();
	      
	      final double[][] audioDataFFT = FFT.FFT1D(audioDataConv, true); 
	      
	/*      for(i=0;i<tempBufferIP.length/2;i++)
	    	  series.add(i*format.getSampleRate()/tempBufferIP.length, audioDataConv[i]);
	  */
	      for(i=0;i<audioDataFFT[0].length/2;i++)
	    	  series.add(i*(format.getSampleRate()/2)/(audioDataFFT[0].length/2), audioDataFFT[0][i]);
	/*      
	      for(i=0;i<audioDataFFT[0].length/2;i++){
	    	  RealAudioDataFFTVY.add((int)audioDataFFT[0][i]);
	    	  RealAudioDataFFTVX.add(i*format.getSampleRate()/audioDataFFT[0].length);
	      }
	  */    
		
		grafico.actualizar(series,tempBufferIP.length/4,format.getSampleRate()/2);
		anl.analiza(series);
		sourceDataLine.write(tempBufferIP, 0, numBytesRead);
			}
	stopp();
	 sourceDataLine.drain();
     sourceDataLine.close();
	    }catch (Exception e) {
	        System.out.println(e);
	        System.exit(0);
	      }//end catch
	}
	
}

}//end outer class AudioCapture02.java
